      DOUBLE PRECISION FUNCTION DS(J2,MI2,MF2,BETA)
C
C ABORDS. THE REDUCED ROTATION MATRIX.  BRAITHWAITE, W.J., CRAMER, J.G.
C REF. IN COMP. PHYS. COMMUN. 3 (1972) 318
C
C     SMALL D.  REDUCED ROTATION MATRIX.
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION N(4)
      EQUIVALENCE(N(1),K1),(N(2),K2),(N(3),K3),(N(4),K4)
C
      DS=0.D0
      K1=J2-MI2
      K2=J2+MI2
      K3=J2-MF2
      K4=J2+MF2
C
      DO 100 K=1,4
      KT=N(K)/2
      IF(N(K)-2*KT) 1000,100,1000
  100 N(K)=KT
      IF(MIN0(K1,K2,K3,K4)) 1000,200,200
C
  200 ARG=.00872664626D0*BETA
      S=DSIN(ARG)
      C=DCOS(ARG)
      K5=K2-K3
      KMAX=MIN0(K1, K3)
      KMIN=MAX0( 0,-K5)
C
C     SPECIAL CASE ROTATIONS.
      IF(C) 400,300,400
  300 KMIN=0
      C=1.D0
      IF(K5) 1000,600,1000
  400 IF(S) 700,500,700
  500 KMIN=K1
      S=1.D0
      IF(K2-K4) 1000,600,1000
  600 KMAX=KMIN
C
  700 K5=K5+KMIN
      K6=K1-KMIN
      K7=K3-KMIN
      K8=K5+KMIN
      K9=K1+K2-K8
      DS=DFLOAT((-1)**(K3-KMIN))*C**K8*S**K9
     1 *DEXP(.5D0*(FACDS(K1)+FACDS(K2)
     1 +FACDS(K3)+FACDS(K4))-(FACDS(K5)+FACDS(K6)+FACDS(K7)
     1 +FACDS(KMIN)))
      IF(KMIN-KMAX) 800,1000,1000
  800 F0=(C/S)**2
      P=1.D0
      DO 900 K=1,KMAX
      I=K-KMAX
      J=1-I
  900 P=1.D0-P*F0*DFLOAT((K6+I)*(K7+I))/DFLOAT((K5+J)*(KMIN+J))
      DS=DS*P
 1000 RETURN
      END
      DOUBLE PRECISION FUNCTION FACDS(N)
C
      IMPLICIT REAL*8(A-H,O-Z)
      DIMENSION FAC1(151)
      DATA IM/0/
C
      IF(N) 100,150,150
  100 FACDS=0.D0
      GO TO 1000
  150 IF(N-150) 200,200,180
  180 FN=N+1
      FACDS=1.D0/(FN*FN)
      FACDS=.918938533195D0-FN+(FN-.5D0)*DLOG(FN)
     1 +(.0833333333333D0-FACDS*(
     1 .00277777777777D0
     2 -FACDS*(.000793650793651D0-.000595238095236D0*FACDS)))/FN
      GO TO 1000
  200 IF(IM-150) 300,500,300
  300 IM=150
      FAC1(1)=0.D0
      DO 400 I=1,IM
  400 FAC1(I+1)=FAC1(I)+DLOG(DFLOAT(I))
  500 FACDS=FAC1(N+1)
 1000 RETURN
      END
