      subroutine PMG2CR(th,ph,thp,php,th2,ph2)
      implicit none
      
c     conversion des coordonnees Body-fixed "a la PMG94" vers celles des
c     Claire;
c     MW, 24.09.04
      
      real*8 :: th,ph,thp,php,th2, ph2
      real*8 :: x2,y2,z2, argph2, pi
      parameter (pi=3.1415926535897932 d0)
      integer :: i
      
      x2 = dsin(thp)*dcos(th)*dcos(ph)*dcos(php)
     $     +dsin(thp)*dcos(th)*dsin(ph)*dsin(php)-dcos(thp)*dsin(th)
      y2 = -dsin(thp)*dsin(ph)*dcos(php)+dsin(thp)*dcos(ph)*dsin(php)
      z2 = dsin(thp)*dsin(th)*dcos(ph)*dcos(php)
     $     +dsin(thp)*dsin(th)*dsin(ph)*dsin(php)+dcos(th)*dcos(thp)
      
      if (dabs(z2) .gt. 1.d0 .or. dabs(x2) .gt. 1.d0
     $     .or. dabs(y2) .gt. 1.d0) then
         stop 'Erreur de conversion des angles'
      end if
      
      th2 = dacos(z2)
c
c     if test below for the special case where input angles th, ph, th2,
c     ph2 are all zero in which case x2=0 and y2=0 (H2 aligned along z)
c     Alex 29/01/2020
c
      if (x2.eq.0 .and. y2.eq.0) then
         argph2= 0.d0
      else
         argph2 = x2/dsqrt(x2**2+y2**2)
      endif
      
      ph2 = dacos(argph2) 

      if (y2 .lt. 0.d0) then
         ph2 =  2.d0*Pi - ph2
      end if
      
      end
